#define F_CPU 16000000UL
#define SPEED 800

#define E1 PD4
#define IN1 PC1
#define IN2 PC2
#define E2 PD5
#define IN3 PC3
#define IN4 PC4

#define led PD7

#define SENZ0 0
#define SENZ1 1
#define SENZ2 2
#define SENZ3 3
#define SENZ4 4
#define ADC_INIT_CHANNEL 0

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

void 
Motor_init()
{
	/* Initializare pin motoare */
	DDRD = 0;
	DDRC = 0;

	DDRD |= (1 << E1) | (1 << E2) | (1 << led);
	//E1 si E2 sun setate ca iesiri
		DDRC |= (1 << IN1) | (1 << IN2) | (1 << IN3) | (1 << IN4);

	PORTC = 0;
	PORTD = 0;
	PORTC |= (1 << IN1) | (1 << IN3);
}

void 
PWM_init()
{
	DDRD |= (1 << E2) | (1 << E1);
	/* Timer */
	TCCR1A |= (1 << WGM10) | (1 << COM1A1) | (1 << COM1B1);
	TCCR1B |= (1 << WGM12) | (1 << CS12) | (1 << CS10);
	OCR1A = 65535;
}
/* initializare analog to digital convertor */
void 
ADC_init()
{
	ADMUX = 0;
	ADMUX = (1 << REFS0) | (1 << MUX0);
	//|(1 << 1) | (1 << 2) | (1 << 3) | (1 << 4);
	ADCSRA = (1 << ADEN) | (1 << ADSC) | (1 << ADIE) | (7 << ADPS0);
}

/* valorile pe care le vad senzorii */
int		ADC_value  [5];
ISR(ADC_vect)
{
	static uint8_t	channel = ADC_INIT_CHANNEL;
	ADC_value[channel] = ADC;

	channel = (channel + 1) % 5;
	ADMUX = (ADMUX & ~(0x1f << MUX0)) | channel;

	ADCSRA |= (1 << ADSC);
}
void 
Speed_m1(uint16_t speed)
{
	OCR1A = speed;
}
void 
Speed_m2(uint16_t speed)
{
	OCR1B = speed;
}

void 
M1_inainte(uint16_t speed)
{
	OCR1A = speed;
	OCR1B = speed;
}


int 
main()
{
	Motor_init();
	PWM_init();
	ADC_init();
	sei();
	DDRA &= ~((1 << PA0) | (1 << PA1) | (1 << PA2) | (1 << PA3) | (1 << PA4));
	while (1) {
		PORTD ^= (1 << led);
		if (ADC_value[0] > 700) {
			Speed_m1(300);
			Speed_m2(700);
		} else if (ADC_value[1] > 700) {
			Speed_m1(500);
			Speed_m2(600);
		} else if (ADC_value[2] > 700) {
			Speed_m1(699);
			Speed_m2(699);
		} else if (ADC_value[3] > 700) {
			Speed_m1(600);
			Speed_m2(500);
		} else if (ADC_value[4] > 700) {
			Speed_m1(700);
			Speed_m2(300);
		}
	}


	return 0;
