#define F_CPU 16000000UL
#define SPEED 800
#define TOPV 825 

#define E1 PD4
#define IN1 PC1
#define IN2 PC2
#define E2 PD5
#define IN3 PC3
#define IN4 PC4

#define led PD7

#define SENZ0 PA1
#define SENZ1 PA2
#define SENZ2 PA3
#define SENZ3 PA4
#define SENZ4 PA5
#define ADC_INIT_CHANNEL 0

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

void Motor_init(){
	/* Initializare pin motoare*/
	DDRD =0;
	DDRC =0;
	
	DDRD |= (1<< E1) | (1<< E2) | (1<<led); //E1 si E2 sun setate ca iesiri
	DDRC |= (1<< IN1 ) | (1<< IN2) | (1<< IN3) | (1<<IN4);

	PORTC =0;
	PORTD =0;
	PORTC |=(1<<IN1) | (1<<IN3);
}

void PWM_init(){
	DDRD |= (1 << E2)| (1 << E1); 
	/*Timer*/
	TCCR1A |= (1 << WGM10) | (1 << COM1A1)| (1<<COM1B1);
	TCCR1B |= (1 << WGM12) | (1 << CS12) | (1 << CS10);
	OCR1A = 65535 /2;
	}
	/*initializare analog to digital convertor*/
void ADC_init()
	{
	ADMUX = 0;
	ADMUX = (1 << REFS0) | (1 << MUX0);// | (1 << 1) | (1 << 2) | (1 << 3) | (1<<4);
	ADCSRA =(1 << ADEN) | (1 << ADSC) | (1 << ADIE) |(7 << ADPS0 );
	}
	
	/*valorile pe care le vad senzorii*/
	int ADC_value[5];
	ISR(ADC_vect)
	{
		static uint8_t channel = ADC_INIT_CHANNEL;
		ADC_value[channel] =ADC;
		
		channel = (channel + 1) % 5;
		ADMUX = (ADMUX &~(0x1f << MUX0)) | channel;
		
		ADCSRA |= (1 << ADSC);
	}
	void Speed_m1(uint16_t speed)
	{
		OCR1A = speed;
	}
	void Speed_m2(uint16_t speed)
	{
		OCR1B = speed;
	}

void M1_inainte(uint16_t speed)
{
		OCR1A = speed;
		OCR1B = speed;
}


int main() {
	Motor_init();
	PWM_init();
	ADC_init();
	sei();
	uint16_t sum = 0;
	DDRA &= ~((1<<PA0) | (1<<PA1) |(1<<PA2) |(1<<PA3) | (1<<PA4) | (1<<PA5));
	PORTA &= ~((1<<PA0) | (1<<PA1) |(1<<PA2) |(1<<PA3) | (1<<PA4)| (1<<PA5));
	while(1) {
		//PORTD ^= (1<<led);
		//sum = 0;
		//sum = ( 0*ADC_value[0] + 1000*ADC_value[1]+2000*ADC_value[2]+3000*ADC_value[3]+4000*ADC_value[4])/(ADC_value[0]+ADC_value[1]+ADC_value[2]+ADC_value[3]+ADC_value[4]);
	
	if(ADC_value[0] > TOPV)
		{ Speed_m1(300);
		  Speed_m2(700);}
		  
		if(ADC_value[1] > TOPV)
		   {  Speed_m1(500);
	   		Speed_m2(600);}
		if(ADC_value[2] > TOPV)
			{ Speed_m1(699);
			  Speed_m2(699);}
	   if(ADC_value[3] > TOPV)
			{ Speed_m1(600);
				Speed_m2(500);}
		if(ADC_value[4] > TOPV)
		{Speed_m1(700);
		Speed_m2(300);}
		
/*if (sum < 2400)
	{Speed_m1(300);
		  Speed_m2(700);}
		  if(sum >2400 && sum < 2500)	{
			  Speed_m1(699);
			  			  Speed_m2(699);
		  }
		  if(sum <= 2500){
			  Speed_m1(700);
			  		Speed_m2(300);
		  }
		
		_delay_ms(20);*/
		
		// if(!bit_is_set(PINA, SENZ0) ){
	// 		Speed_m1(300);
	// 		Speed_m2(200);
	// 	}
	// 		else if (!bit_is_set(PINA, SENZ1)){
	// 			Speed_m1(250);
	// 			Speed_m2(300);
	// 		} else
	// 	
	// 	if(!bit_is_set(PINA, SENZ2)){
	// 			Speed_m1(300);
	// 			Speed_m2(300);
	// 	} else
	// 	if(!bit_is_set(PINA, SENZ3)){
	// 		Speed_m1(250);
	// 		Speed_m2(200);
	// 	} else
	// 	if ( !bit_is_set(PINA, SENZ4)){
	// 		Speed_m1(200);
	// 		Speed_m2(300);
	// 	}
			
		_delay_ms(50);				
	}
						
	return 0;
}